<template>
	<el-dialog v-model="visible" title="查看" width="75%" :close-on-click-modal="false" @close="onCancel">
		<el-form :model="form" label-width="110px" label-position="top" :rules="rules" ref="formRef">
			<el-row :gutter="16">
				<el-col :span="8">
					<el-form-item label="借用单编号" prop="application_no">
						<el-input v-model="form.application_no" placeholder="自动生成" disabled />
					</el-form-item>
				</el-col>
				<el-col :span="8">
					<el-form-item label="借用人类型" prop="borrower_type">
					<el-select v-model="form.borrower_type" placeholder="请选择借用人角色"  :disabled="isView" >
						<el-option label="管理员用户" :value=0 />
						<el-option label="应用用户" :value=1 />
						<el-option label="外部用户" :value=2 />
					</el-select>
					</el-form-item>
				</el-col>
				<el-col :span="8" >
					<el-form-item label="借用人" prop="admin_borrower" v-if="form.borrower_type == 0">
					<el-select v-model="form.admin_borrower" placeholder="请选择借用人"  :disabled="isView" >
						<el-option  :label="adminList.name" :value="adminList.id" />
					</el-select>
					</el-form-item>
					<el-form-item label="借用人" prop="app_user_borrower" v-if="form.borrower_type == 1">
					<el-select v-model="form.app_user_borrower" placeholder="请选择借用人"  :disabled="isView" >
						<el-option v-for="item in allUserList"  :key="item.id" :label="item.name" :value="item.id" />
					</el-select>
					</el-form-item>
					<el-form-item label="借用人" prop="external_borrower_name" v-if="form.borrower_type == 2">
					<el-input v-model="form.external_borrower_name" placeholder="请输入借用人"  :disabled="isView"/>
					</el-form-item>
				</el-col>
				<el-col :span="8" v-if="form.borrower_type !== 2">
					<el-form-item label="学号/工号" prop="user_code" >
						<el-input v-model="form.user_code" placeholder="请输入学号/工号"  :disabled="isView"/>
					</el-form-item>
				</el-col>
				<el-col :span="8">
					<el-form-item label="联系电话" prop="mobile" v-if="form.borrower_type !== 2">
						<el-input v-model="form.mobile" placeholder="请输入联系电话" :disabled="isView" />
					</el-form-item>
					<el-form-item label="联系电话" prop="external_borrower_phone" v-if="form.borrower_type == 2">
						<el-input v-model="form.external_borrower_phone" placeholder="请输入联系电话"  :disabled="isView"/>
					</el-form-item>
				</el-col>
				<el-col :span="8">
					<el-form-item label="借用部门" prop="borrower_dept">
						<el-input v-model="form.borrower_dept" placeholder="请输入借用部门" :disabled="isView" />
					</el-form-item>
				</el-col>
				<el-col :span="8">
					<el-form-item label="预计归还时间" prop="expected_end_time">
						<el-date-picker v-model="form.expected_end_time" type="datetime" placeholder="请选择预计归还时间" style="width: 100%"  :disabled="isView"/>
					</el-form-item>
				</el-col>
				<el-col :span="4">
					<el-form-item label="个人/团队" prop="team_type" >
						<el-select v-model="form.team_type" placeholder="请选择" :disabled="isView">
							<el-option label="个人" :value="0" />
							<el-option label="团队" :value="1" />
						</el-select>
					</el-form-item>
				</el-col>
				<el-col :span="4" v-show="form.team_type===1">
					<el-form-item label="团队人数" prop="team_members_count">
						<el-input v-model="form.team_members_count" placeholder="请输入"  :disabled="isView"/>
					</el-form-item>
				</el-col>
				<el-col :span="16" v-show="form.team_type===1">
					<el-form-item label="团队其他人员名单" prop="team_members">
						<el-input v-model="form.team_members" placeholder="请输入团队其他人员名单"  :disabled="isView"/>
					</el-form-item>
				</el-col>
				<el-col :span="24">
					<el-form-item label="借用原因" prop="purpose">
						<el-input v-model="form.purpose" type="textarea" placeholder="请输入借用原因" :disabled="isView" />
					</el-form-item>
				</el-col>
				<el-col :span="4">
					<el-form-item label="审批人" prop="applicant_remark_type">
						<el-select v-model="form.applicant_remark_type" placeholder="请选择" :disabled="isView" >
							<el-option label="管理员" value="1"/>
						</el-select>
					</el-form-item>
				</el-col>
				<el-col :span="20">
					<el-form-item label="备注" prop="applicant_remark">
						<el-input v-model="form.applicant_remark" placeholder="请输入备注"  :disabled="isView"/>
					</el-form-item>
				</el-col>
			</el-row>
			<div style="margin: 16px 0 8px 0; font-weight: bold">借用列表</div>
			<!-- {{ isEdit }} -->
			<el-table :data="!isEdit ? form.items : form.items.filter(item => item.device === null)" border style="width: 100%; margin-bottom: 12px">
				<el-table-column type="index" label="序号" width="60" />
				<el-table-column prop="device_category_name" label="设备分类" />
				<!-- <el-table-column prop="quantity" label="借用数量" /> -->
				<el-table-column label="借用数量">
				<template #default="{ row }">
				<el-input v-model="row.quantity" type="number" :min="1" prop="quantity" size="small" :disabled="isView" />
				</template>
				</el-table-column>
				<el-table-column prop="location" label="存放仓库" />
				<el-table-column label="操作" width="80">
					<template #default="{ row, $index }">
						<el-button type="text" style="color: red" @click="removeItem($index)" :disabled="isView">移除</el-button>
					</template>
				</el-table-column>
			</el-table>
			<el-button type="primary" @click="addItem" v-if="!isView">添加设备</el-button>
			<div style="margin: 16px 0 8px 0; font-weight: bold">配件信息</div>
			<el-input v-model="form.accessories" placeholder="请输入配件信息"  :disabled="isView"/>

			<div style="margin: 16px 0 8px 0; font-weight: bold">附件</div>
			<div>
			<el-upload
			list-type="picture-card"
			:show-file-list="true"
			:http-request="handleCustomUpload"
			:file-list="fileList"
			style="margin-top: 10px;"
			>
			<el-icon><Plus /></el-icon>
			</el-upload>
		    </div>

		</el-form>
		<!-- 审批信息流程展示 -->
		<div v-if="isView"  style="margin-top: 24px; padding: 0 12px">
		<div style="font-weight: bold; margin-bottom: 12px">审批流程进度</div>
		<el-steps :active="steps.length" align-center>
			<el-step
				v-for="(step, index) in steps"
				:key="index"
				:title="step.title"
				:description="step.description"
				icon="CircleCheck"
				:status="step.status"
			/>
			</el-steps>

		</div>

		<template #footer>
			<el-button type="success" @click="onSucess">通过</el-button>
			<el-button  type="danger"  @click="onDanger(form.id)">拒绝</el-button>
			<el-button @click="onCancel">关闭</el-button>
			<el-button type="primary" @click="onSubmit" v-if="!isView">提交</el-button>
		</template>
	</el-dialog>
	<SelectDeviceDialogApp v-model:visible="showSelectDeviceDialog" @confirm="onDeviceSelected" />
	<!-- <SelectCatgory v-model:visible="showSelectDeviceDialog" @confirm="onDeviceSelected" /> -->
	<RefuseNotification/>
</template>

<script setup lang="ts">
import { ref, inject,provide,watch, defineProps, defineEmits, onMounted,computed } from 'vue';
import SelectDeviceDialogApp from './SelectDeviceDialogApp/index.vue';
import RefuseNotification from '../RefuseNotification/index.vue';
import dayjs from 'dayjs';
import { ElMessage } from 'element-plus';
import * as api from '../api';
import * as apis from '../../api';
import Cookies from 'js-cookie';
import { request } from '/@/utils/service';
import { Plus } from '@element-plus/icons-vue';
// import SelectDeviceDialog from './SelectDeviceDialogApp/index.vue';
import { getUserInfo,getAdminUserInfo } from '../../../login/api';

const showRejectDialog = ref(false);
const rejectReason = ref('');
const currentFormId = ref<number | null>(null);

provide('showRejectDialog', showRejectDialog);
provide('rejectReason', rejectReason);
provide('currentFormId', currentFormId);
provide('closeDialog', onCancel);

const crudExpose = inject('crudExpose') as any;
provide('crudExpose', crudExpose); 


/* 获取管理员列表 */
const adminList = ref([]);

async function getAdminList() {
	const res = await getUserInfo();
	adminList.value = res.data;
	console.log("adminList.value:::",adminList.value)	
}

/* 获取所有用户 */
const allUserList = ref([]);
async function getAllUserList() {
	const res = await apis.GetAllUser();
	allUserList.value = res.data||[];
	const adminRes = await getAdminUserInfo();
	const adminUser = adminRes.data;
	// // 设置默认选择第一个用户
	// if (allUserList.value.length > 0) {
	// 	form.value.app_user_borrower = allUserList.value[0].id;
	// }

    // 检查是否已存在该用户，避免重复添加
    const exists = allUserList.value.some(user => user.id === adminUser.id);
    if (!exists) {
      allUserList.value.push(adminUser);
    }
	console.log("allUserList.value:::",allUserList.value)	
}



const now = dayjs().format('YYYY-MM-DD HH:mm:ss');


const props = defineProps<{ visible: boolean; modelValue?: any }>();

const isEdit = computed(() => props.modelValue?.mode === 'edit');
const isView = computed(() => props.modelValue?.mode === 'view');
const isAdd = computed(() => props.modelValue?.mode === 'add');

const emit = defineEmits(['update:visible', 'update:modelValue', 'submit']);
const visible = ref(props.visible);
const formRef = ref();


const fileList = ref([]);

// const fileList = ref([]);
const handleCustomUpload = async ({ file, onProgress, onSuccess, onError }: any) => {
  const token = Cookies.get('token'); 
  const formData = new FormData();
  formData.append('file', file);
//   console.log("token::::",token);

  try {
    const res = await request({
		url: `/api/system/upload/`,
		method: 'post',
		headers: {
			'Content-Type': 'multipart/form-data',
			Authorization: 'JWT '+ token,
		},
		data: formData,
		timeout: 60000,
		onUploadProgress: (p: any) => {
                            onProgress({percent: Math.round((p.loaded / p.total) * 100)});
		}
    });

	// 构造 Element Plus 需要的 file 对象
	const fileObj = {
      name: res.data.name,
      url: res.data.url,
      status: 'success',
      response: res.data
    };

    // 添加到附件列表
	form.value.attachments = fileObj.url; 

    ElMessage.success('上传成功');
    onSuccess(fileObj); 
  } catch (error) {
    ElMessage.error('上传失败');
    onError(error);
  }
};

// import { ElSteps } from 'element-plus';
const steps = ref<any[]>([]);
const timeline = ref({
	setpstatus:0,
	create: '',
	approve: '',
	approver: '',
	approvemsg:''
});


function buildSteps(data: any) {
  steps.value = [
    {
      title: '创建申请',
      description: `创建时间：${data.create_datetime}`,
      status: 'finish'
    },
    {
      title: '待审批',
      description: '待超级管理员审批',
      status: data.status >= 2 ? 'finish' : 'process'
    }
  ];

  if (data.status >= 2 &&data.status!=3) {
    steps.value.push({
      title: '审批通过',
      description: `审批人：${data.approver_info.name}，时间：${data.approve_time}`,
      status: 'finish'
    });
  } else if (data.status === 3) {
    steps.value.push({
      title: '审批拒绝',
      description: `审批人：${data.approver_info.name}，拒绝原因: ${data.approve_remark},时间：${data.approve_time}`,
      status: 'error'
    });
  }

  if (data.status >= 4) {
    steps.value.push({
      title: '流程完成',
      description: '流程已结束',
      status: 'finish'
    });
  }
}

// const activeStep = ref(1);



const form = ref({
	borrower_type: 1,
	application_no: '',
	external_borrower_name:"",
	external_borrower_phone:"",
	emergency_contact: '111',
	emergency_phone: '11111',
	app_user_borrower: 1,
	team_type: 0,
	team_members_count: 2,
	team_members: '',
	expected_start_time:'',
	expected_end_time: '',
	borrower_dept: '',
	purpose: '',
	applicant_remark_type: "1",
	applicant_remark: '',
	items: [],
	accessories: '',
	mobile:'',
	user_code:'',
	borrow_type: 2,
	return_location:'',
	attachments:'',
	admin_borrower:''
});
const showSelectDeviceDialog = ref(false);


const rules = {
   external_borrower_name: [
    { required: true, message: '请输入借用人', trigger: 'change' },
  ],
  app_user_borrower: [
    { required: true, message: '请输入学号或工号', trigger: 'change' },
  ],
  external_borrower_phone: [
    { required: true, message: '请输入联系电话', trigger: 'change' },
  ],
  borrower_dept: [
    { required: true, message: '请输入借用部门', trigger: 'change' },
  ],
  expected_end_time: [
    { required: true, message: '请输选择归还时间', trigger: 'change' },
  ],
  team_type: [
    { required: true, message: '请选择个人或者团队', trigger: 'change' },
  ],
  purpose: [
    { required: true, message: '请输入借用原因', trigger: 'change' },
  ],
  applicant_remark_type: [
    { required: true, message: '请选择审批人', trigger: 'change' },
  ],
  applicant_remark: [
    { required: true, message: '请输入备注', trigger: 'change' },
  ],
};


// 自动填充用户信息
onMounted(() => {
	try {
		getAllUserList()
		const bortype=props.modelValue.borrower_type;
		if(bortype==0){
			getAdminList()
			
		}else if(bortype==1){
			const userInfo = props.modelValue.borrower_info;
			if (userInfo) {
				form.value.borrower_type = 1;
				form.value.app_user_borrower = userInfo.id || '';
				// form.value.app_user_borrower = Number(userInfo.dept_info?.dept_id )|| 1;
				form.value.user_code=userInfo.user_code||'';
				form.value.mobile=userInfo.mobile||'';
				form.value.borrower_dept = userInfo.dept_info?.dept_name || '';
			}
			console.log("form.value1111:",form.value);
		}else if(bortype==2){
			const userInfo = props.modelValue.borrower_info;
			if (userInfo) {
				form.value.borrower_type =2;
				form.value.external_borrower_name = userInfo.id || '';
				// form.value.app_user_borrower = Number(userInfo.dept_info?.dept_id )|| 1;
				form.value.user_code=userInfo.user_code||'';
				form.value.external_borrower_phone = userInfo.mobile || '';
				form.value.borrower_dept = userInfo.dept_info?.dept_name || '';
			}
		}
		
	} catch (e) {
		/* empty */
	}
});

watch(
	() => props.visible,
	(v) => (visible.value = v)
);

watch(() => props.modelValue, async (val) => {
	console.log("val+++",val && val.id && isView.value,val&& isEdit.value);
  if (val && val.id && isView.value) {
			try {
			const res = await apis.GetApplicationDetail(val.id);
			if (res.code === 2000 && res.data) {
				const data = res.data;
				Object.assign(form.value, data);
				buildSteps(data);
				form.value.app_user_borrower = res.data.app_user_borrower?.id || '';

       
			}
			} catch (e) {
			  ElMessage.error('获取审批信息失败');
			}
	}else if(val&& isEdit.value){
		try {
			const res = await apis.GetApplicationDetail(val.id);
	
			if (res.code === 2000 && res.data) {
				const data = res.data;
				Object.assign(form.value, data);
				form.value.app_user_borrower = res.data.app_user_borrower?.id || '';
			}
			} catch (e) {
			  ElMessage.error('获取审批信息失败');
			}
	}
}, { immediate: true });
// 监听借用人选择变化
watch(() => form.value.app_user_borrower, (newValue) => {
  if (newValue && allUserList.value.length > 0) {
    const selectedUser = allUserList.value.find(user => user.id === newValue);
    if (selectedUser) {
      form.value.user_code = selectedUser.user_code || '';
	  form.value.mobile = selectedUser.mobile || '';
    }
  }
});

// watch(
// 	() => props.modelValue,
// 	(v) => {
// 		if (v) {
// 			// eslint-disable-next-line no-console
// 			console.log("val:::::",v);
// 			Object.assign(form.value, v);
// 		}
// 	}, { immediate: true }
// );

function addItem() {
	showSelectDeviceDialog.value = true;
}
function onDeviceSelected(devices) {
	console.log("devices:::",devices);
	form.value.items.push(
		...devices.map((d) => ({
			device_category: d.id,
			remark: d.name,
			quantity: 1,
			location: d.warehouse,
		}))
	);
}
function removeItem(index: number) {
	form.value.items.splice(index, 1);
}

async function onDanger(formId: number){
	currentFormId.value = formId;
	showRejectDialog.value = true;
}

async function onSucess(){
	const ids=props.modelValue.id;
	await api.BorrowingReview(ids, "approve", "同意借用");
	ElMessage.success("审批通过");
	emit('update:visible', false);
	crudExpose?.doRefresh();
}




function onCancel() {
	emit('update:visible', false);
}
function onSubmit() {
	
	formRef.value.validate((valid: boolean) => {
		if (valid) {
			form.value.items = form.value.items.map(item => ({
                ...item,
                quantity: Number(item.quantity) || 0  
            }));
			const firstLocation = form.value.items[0]?.location || '';
            form.value.return_location = firstLocation;
			form.value.expected_start_time = now;
			form.value.expected_end_time = dayjs(form.value.expected_end_time).format('YYYY-MM-DD HH:mm:ss')|| now;
			form.team_members_count=Number(form.value.team_members_count)||1;
			form.value.mode = isEdit.value ? 'edit' : 'add';
			console.log(form.value);
			// return
			emit('submit', { ...form.value });
			emit('update:visible', false);
			// ElMessage.success("添加成功！");
		}
	});
	
}

</script>
